/*
  File autogenerated by gengetopt version 2.22.6
  generated with the following command:
  gengetopt -i bsmem.ggo --no-handle-version --include-getopt

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef FIX_UNUSED
#define FIX_UNUSED(X) (void) (X) /* avoid warnings for unused params */
#endif


#include "cmdline.h"

const char *gengetopt_args_info_purpose = "Reconstruct an image from optical interferometry data";

const char *gengetopt_args_info_usage = "Usage: bsmem [OPTIONS]...";

const char *gengetopt_args_info_versiontext = "";

const char *gengetopt_args_info_description = "BSMEM applies a fully Bayesian approach to the inverse problem of finding the\nmost probable image from optical (visible/IR) interferometry data.";

const char *gengetopt_args_info_help[] = {
  "  -h, --help             Print help and exit",
  "  -V, --version          Print version and exit",
  "      --noui             Disable user prompts and plotting  (default=off)",
  "\nData Selection:",
  "  -d, --data=STRING      Input OIFITS data filename",
  "  -f, --output=STRING    Output filename  (default=`output.fits')",
  "      --clobber          Overwrite existing output file  (default=off)",
  "  -t, --target=STRING    Name of target to select",
  "      --wavmin=FLOAT     Minimum wavelength to select (nm)  (default=`0.0')",
  "      --wavmax=FLOAT     Maximum wavelength to select (nm)  (default=`1E9')",
  "      --uvmax=FLOAT      Maximum uv radius to select (waves)  (default=`1E11')",
  "\nAlgorithm Settings (generic):",
  "      --it=INT           Maximum number of iterations to run  (default=`200')",
  "  -e, --regul=INT        Regularization function\n                           1: Gull-Skilling entropy\n                           2: Positive/negative Gull-Skilling entropy\n                           4: Quadratic  (possible values=\"1\", \"2\", \"4\"\n                           default=`1')",
  "  -r, --autoalpha=INT    Regularization hyperparameter estimation\n                           1: Classic Bayesian with known noise scale\n                           2: Classic Bayesian with simultaneous estimation of\n                           the noise scale\n                           3: Uses the user-provided alpha value\n                           4: Historic Chisquared=Ndata (fast, but\n                           non-Bayesian)  (possible values=\"1\", \"2\", \"3\",\n                           \"4\" default=`4')",
  "  -a, --alpha=FLOAT      Regularization hyperparameter (-r 3 to enable)\n                           (default=`100.0')",
  "      --ferr=FLOAT       Error on zero baseline powerspectrum  (default=`0.1')",
  "\nAlgorithm Settings (BSMEM-specific):",
  "      --berr=INT         Type of errors on the rotated bispectrum vector\n                           0: Classic elliptic approximation\n                           1: 'Full' elliptic approximation (Meimon et al.)\n                           (possible values=\"0\", \"1\" default=`0')",
  "      --v2a=FLOAT        Multiplicative factor a for powerspectrum errors\n                           (e'= a * e + b)  (default=`1.0')",
  "      --v2b=FLOAT        Additive offset b for powerspectrum errors\n                           (e'= a * e + b)  (default=`0.0')",
  "      --t3ampa=FLOAT     Multiplicative factor a for triple amplitude errors\n                           (e'= a * e + b)  (default=`1.0')",
  "      --t3ampb=FLOAT     Additive offset b for triple amplitude errors\n                           (e'= a * e + b)  (default=`0.0')",
  "      --t3phia=FLOAT     Multiplicative factor a for closure phase errors\n                           (e'= a * e + b)  (default=`1.0')",
  "      --t3phib=FLOAT     Additive offset b for closure phase errors\n                           (e'= a * e + b)  (default=`0.0')",
  "      --forcext          Force triple amplitude computation from powerspectra\n                           (default=off)",
  "\nImage Parameters:",
  "  -w, --dim=INT          Reconstructed image width (pixels)  (default=`128')",
  "  -p, --pixelsize=FLOAT  Reconstructed image pixel size (mas)\n                           (default=automatic)",
  "      --mf=FLOAT         Total flux of the initial/prior image\n                           (default=`0.01')",
  "\n Mode: model\n  Initial/prior image specified as parameterized model",
  "      --mt=INT           Initial/prior image model type\n                           0: flat\n                           1: Dirac\n                           2: uniform disk\n                           3: Gaussian\n                           4: Lorentzian  (possible values=\"0\", \"1\", \"2\",\n                           \"3\", \"4\" default=`3')",
  "      --mw=FLOAT         Initial/prior image model width (mas)\n                           (default=`10.0')",
  "\n Mode: image\n  Initial/prior image in user-supplied FITS file",
  "      --sf=STRING        Initial/prior image filename",
    0
};

typedef enum {ARG_NO
  , ARG_FLAG
  , ARG_STRING
  , ARG_INT
  , ARG_FLOAT
} cmdline_parser_arg_type;

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char **argv, struct gengetopt_args_info *args_info,
                        struct cmdline_parser_params *params, const char *additional_error);

static int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error);

const char *cmdline_parser_regul_values[] = {"1", "2", "4", 0}; /*< Possible values for regul. */
const char *cmdline_parser_autoalpha_values[] = {"1", "2", "3", "4", 0}; /*< Possible values for autoalpha. */
const char *cmdline_parser_berr_values[] = {"0", "1", 0}; /*< Possible values for berr. */
const char *cmdline_parser_mt_values[] = {"0", "1", "2", "3", "4", 0}; /*< Possible values for mt. */

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->noui_given = 0 ;
  args_info->data_given = 0 ;
  args_info->output_given = 0 ;
  args_info->clobber_given = 0 ;
  args_info->target_given = 0 ;
  args_info->wavmin_given = 0 ;
  args_info->wavmax_given = 0 ;
  args_info->uvmax_given = 0 ;
  args_info->it_given = 0 ;
  args_info->regul_given = 0 ;
  args_info->autoalpha_given = 0 ;
  args_info->alpha_given = 0 ;
  args_info->ferr_given = 0 ;
  args_info->berr_given = 0 ;
  args_info->v2a_given = 0 ;
  args_info->v2b_given = 0 ;
  args_info->t3ampa_given = 0 ;
  args_info->t3ampb_given = 0 ;
  args_info->t3phia_given = 0 ;
  args_info->t3phib_given = 0 ;
  args_info->forcext_given = 0 ;
  args_info->dim_given = 0 ;
  args_info->pixelsize_given = 0 ;
  args_info->mf_given = 0 ;
  args_info->mt_given = 0 ;
  args_info->mw_given = 0 ;
  args_info->sf_given = 0 ;
  args_info->image_mode_counter = 0 ;
  args_info->model_mode_counter = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  FIX_UNUSED (args_info);
  args_info->noui_flag = 0;
  args_info->data_arg = NULL;
  args_info->data_orig = NULL;
  args_info->output_arg = gengetopt_strdup ("output.fits");
  args_info->output_orig = NULL;
  args_info->clobber_flag = 0;
  args_info->target_arg = NULL;
  args_info->target_orig = NULL;
  args_info->wavmin_arg = 0.0;
  args_info->wavmin_orig = NULL;
  args_info->wavmax_arg = 1E9;
  args_info->wavmax_orig = NULL;
  args_info->uvmax_arg = 1E11;
  args_info->uvmax_orig = NULL;
  args_info->it_arg = 200;
  args_info->it_orig = NULL;
  args_info->regul_arg = 1;
  args_info->regul_orig = NULL;
  args_info->autoalpha_arg = 4;
  args_info->autoalpha_orig = NULL;
  args_info->alpha_arg = 100.0;
  args_info->alpha_orig = NULL;
  args_info->ferr_arg = 0.1;
  args_info->ferr_orig = NULL;
  args_info->berr_arg = 0;
  args_info->berr_orig = NULL;
  args_info->v2a_arg = 1.0;
  args_info->v2a_orig = NULL;
  args_info->v2b_arg = 0.0;
  args_info->v2b_orig = NULL;
  args_info->t3ampa_arg = 1.0;
  args_info->t3ampa_orig = NULL;
  args_info->t3ampb_arg = 0.0;
  args_info->t3ampb_orig = NULL;
  args_info->t3phia_arg = 1.0;
  args_info->t3phia_orig = NULL;
  args_info->t3phib_arg = 0.0;
  args_info->t3phib_orig = NULL;
  args_info->forcext_flag = 0;
  args_info->dim_arg = 128;
  args_info->dim_orig = NULL;
  args_info->pixelsize_orig = NULL;
  args_info->mf_arg = 0.01;
  args_info->mf_orig = NULL;
  args_info->mt_arg = 3;
  args_info->mt_orig = NULL;
  args_info->mw_arg = 10.0;
  args_info->mw_orig = NULL;
  args_info->sf_arg = NULL;
  args_info->sf_orig = NULL;
  
}

static
void init_args_info(struct gengetopt_args_info *args_info)
{


  args_info->help_help = gengetopt_args_info_help[0] ;
  args_info->version_help = gengetopt_args_info_help[1] ;
  args_info->noui_help = gengetopt_args_info_help[2] ;
  args_info->data_help = gengetopt_args_info_help[4] ;
  args_info->output_help = gengetopt_args_info_help[5] ;
  args_info->clobber_help = gengetopt_args_info_help[6] ;
  args_info->target_help = gengetopt_args_info_help[7] ;
  args_info->wavmin_help = gengetopt_args_info_help[8] ;
  args_info->wavmax_help = gengetopt_args_info_help[9] ;
  args_info->uvmax_help = gengetopt_args_info_help[10] ;
  args_info->it_help = gengetopt_args_info_help[12] ;
  args_info->regul_help = gengetopt_args_info_help[13] ;
  args_info->autoalpha_help = gengetopt_args_info_help[14] ;
  args_info->alpha_help = gengetopt_args_info_help[15] ;
  args_info->ferr_help = gengetopt_args_info_help[16] ;
  args_info->berr_help = gengetopt_args_info_help[18] ;
  args_info->v2a_help = gengetopt_args_info_help[19] ;
  args_info->v2b_help = gengetopt_args_info_help[20] ;
  args_info->t3ampa_help = gengetopt_args_info_help[21] ;
  args_info->t3ampb_help = gengetopt_args_info_help[22] ;
  args_info->t3phia_help = gengetopt_args_info_help[23] ;
  args_info->t3phib_help = gengetopt_args_info_help[24] ;
  args_info->forcext_help = gengetopt_args_info_help[25] ;
  args_info->dim_help = gengetopt_args_info_help[27] ;
  args_info->pixelsize_help = gengetopt_args_info_help[28] ;
  args_info->mf_help = gengetopt_args_info_help[29] ;
  args_info->mt_help = gengetopt_args_info_help[31] ;
  args_info->mw_help = gengetopt_args_info_help[32] ;
  args_info->sf_help = gengetopt_args_info_help[34] ;
  
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n",
     (strlen(CMDLINE_PARSER_PACKAGE_NAME) ? CMDLINE_PARSER_PACKAGE_NAME : CMDLINE_PARSER_PACKAGE),
     CMDLINE_PARSER_VERSION);

  if (strlen(gengetopt_args_info_versiontext) > 0)
    printf("\n%s\n", gengetopt_args_info_versiontext);
}

static void print_help_common(void) {
  cmdline_parser_print_version ();

  if (strlen(gengetopt_args_info_purpose) > 0)
    printf("\n%s\n", gengetopt_args_info_purpose);

  if (strlen(gengetopt_args_info_usage) > 0)
    printf("\n%s\n", gengetopt_args_info_usage);

  printf("\n");

  if (strlen(gengetopt_args_info_description) > 0)
    printf("%s\n\n", gengetopt_args_info_description);
}

void
cmdline_parser_print_help (void)
{
  int i = 0;
  print_help_common();
  while (gengetopt_args_info_help[i])
    printf("%s\n", gengetopt_args_info_help[i++]);
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);
}

void
cmdline_parser_params_init(struct cmdline_parser_params *params)
{
  if (params)
    { 
      params->override = 0;
      params->initialize = 1;
      params->check_required = 1;
      params->check_ambiguity = 0;
      params->print_errors = 1;
    }
}

struct cmdline_parser_params *
cmdline_parser_params_create(void)
{
  struct cmdline_parser_params *params = 
    (struct cmdline_parser_params *)malloc(sizeof(struct cmdline_parser_params));
  cmdline_parser_params_init(params);  
  return params;
}

static void
free_string_field (char **s)
{
  if (*s)
    {
      free (*s);
      *s = 0;
    }
}


static void
cmdline_parser_release (struct gengetopt_args_info *args_info)
{

  free_string_field (&(args_info->data_arg));
  free_string_field (&(args_info->data_orig));
  free_string_field (&(args_info->output_arg));
  free_string_field (&(args_info->output_orig));
  free_string_field (&(args_info->target_arg));
  free_string_field (&(args_info->target_orig));
  free_string_field (&(args_info->wavmin_orig));
  free_string_field (&(args_info->wavmax_orig));
  free_string_field (&(args_info->uvmax_orig));
  free_string_field (&(args_info->it_orig));
  free_string_field (&(args_info->regul_orig));
  free_string_field (&(args_info->autoalpha_orig));
  free_string_field (&(args_info->alpha_orig));
  free_string_field (&(args_info->ferr_orig));
  free_string_field (&(args_info->berr_orig));
  free_string_field (&(args_info->v2a_orig));
  free_string_field (&(args_info->v2b_orig));
  free_string_field (&(args_info->t3ampa_orig));
  free_string_field (&(args_info->t3ampb_orig));
  free_string_field (&(args_info->t3phia_orig));
  free_string_field (&(args_info->t3phib_orig));
  free_string_field (&(args_info->dim_orig));
  free_string_field (&(args_info->pixelsize_orig));
  free_string_field (&(args_info->mf_orig));
  free_string_field (&(args_info->mt_orig));
  free_string_field (&(args_info->mw_orig));
  free_string_field (&(args_info->sf_arg));
  free_string_field (&(args_info->sf_orig));
  
  

  clear_given (args_info);
}

/**
 * @param val the value to check
 * @param values the possible values
 * @return the index of the matched value:
 * -1 if no value matched,
 * -2 if more than one value has matched
 */
static int
check_possible_values(const char *val, const char *values[])
{
  int i, found, last;
  size_t len;

  if (!val)   /* otherwise strlen() crashes below */
    return -1; /* -1 means no argument for the option */

  found = last = 0;

  for (i = 0, len = strlen(val); values[i]; ++i)
    {
      if (strncmp(val, values[i], len) == 0)
        {
          ++found;
          last = i;
          if (strlen(values[i]) == len)
            return i; /* exact macth no need to check more */
        }
    }

  if (found == 1) /* one match: OK */
    return last;

  return (found ? -2 : -1); /* return many values or none matched */
}


static void
write_into_file(FILE *outfile, const char *opt, const char *arg, const char *values[])
{
  int found = -1;
  if (arg) {
    if (values) {
      found = check_possible_values(arg, values);      
    }
    if (found >= 0)
      fprintf(outfile, "%s=\"%s\" # %s\n", opt, arg, values[found]);
    else
      fprintf(outfile, "%s=\"%s\"\n", opt, arg);
  } else {
    fprintf(outfile, "%s\n", opt);
  }
}


int
cmdline_parser_dump(FILE *outfile, struct gengetopt_args_info *args_info)
{
  int i = 0;

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot dump options to stream\n", CMDLINE_PARSER_PACKAGE);
      return EXIT_FAILURE;
    }

  if (args_info->help_given)
    write_into_file(outfile, "help", 0, 0 );
  if (args_info->version_given)
    write_into_file(outfile, "version", 0, 0 );
  if (args_info->noui_given)
    write_into_file(outfile, "noui", 0, 0 );
  if (args_info->data_given)
    write_into_file(outfile, "data", args_info->data_orig, 0);
  if (args_info->output_given)
    write_into_file(outfile, "output", args_info->output_orig, 0);
  if (args_info->clobber_given)
    write_into_file(outfile, "clobber", 0, 0 );
  if (args_info->target_given)
    write_into_file(outfile, "target", args_info->target_orig, 0);
  if (args_info->wavmin_given)
    write_into_file(outfile, "wavmin", args_info->wavmin_orig, 0);
  if (args_info->wavmax_given)
    write_into_file(outfile, "wavmax", args_info->wavmax_orig, 0);
  if (args_info->uvmax_given)
    write_into_file(outfile, "uvmax", args_info->uvmax_orig, 0);
  if (args_info->it_given)
    write_into_file(outfile, "it", args_info->it_orig, 0);
  if (args_info->regul_given)
    write_into_file(outfile, "regul", args_info->regul_orig, cmdline_parser_regul_values);
  if (args_info->autoalpha_given)
    write_into_file(outfile, "autoalpha", args_info->autoalpha_orig, cmdline_parser_autoalpha_values);
  if (args_info->alpha_given)
    write_into_file(outfile, "alpha", args_info->alpha_orig, 0);
  if (args_info->ferr_given)
    write_into_file(outfile, "ferr", args_info->ferr_orig, 0);
  if (args_info->berr_given)
    write_into_file(outfile, "berr", args_info->berr_orig, cmdline_parser_berr_values);
  if (args_info->v2a_given)
    write_into_file(outfile, "v2a", args_info->v2a_orig, 0);
  if (args_info->v2b_given)
    write_into_file(outfile, "v2b", args_info->v2b_orig, 0);
  if (args_info->t3ampa_given)
    write_into_file(outfile, "t3ampa", args_info->t3ampa_orig, 0);
  if (args_info->t3ampb_given)
    write_into_file(outfile, "t3ampb", args_info->t3ampb_orig, 0);
  if (args_info->t3phia_given)
    write_into_file(outfile, "t3phia", args_info->t3phia_orig, 0);
  if (args_info->t3phib_given)
    write_into_file(outfile, "t3phib", args_info->t3phib_orig, 0);
  if (args_info->forcext_given)
    write_into_file(outfile, "forcext", 0, 0 );
  if (args_info->dim_given)
    write_into_file(outfile, "dim", args_info->dim_orig, 0);
  if (args_info->pixelsize_given)
    write_into_file(outfile, "pixelsize", args_info->pixelsize_orig, 0);
  if (args_info->mf_given)
    write_into_file(outfile, "mf", args_info->mf_orig, 0);
  if (args_info->mt_given)
    write_into_file(outfile, "mt", args_info->mt_orig, cmdline_parser_mt_values);
  if (args_info->mw_given)
    write_into_file(outfile, "mw", args_info->mw_orig, 0);
  if (args_info->sf_given)
    write_into_file(outfile, "sf", args_info->sf_orig, 0);
  

  i = EXIT_SUCCESS;
  return i;
}

int
cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  i = cmdline_parser_dump(outfile, args_info);
  fclose (outfile);

  return i;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  cmdline_parser_release (args_info);
}

/** @brief replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = 0;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char **argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser_ext (int argc, char **argv, struct gengetopt_args_info *args_info,
                   struct cmdline_parser_params *params)
{
  int result;
  result = cmdline_parser_internal (argc, argv, args_info, params, 0);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser2 (int argc, char **argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;
  struct cmdline_parser_params params;
  
  params.override = override;
  params.initialize = initialize;
  params.check_required = check_required;
  params.check_ambiguity = 0;
  params.print_errors = 1;

  result = cmdline_parser_internal (argc, argv, args_info, &params, 0);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  int result = EXIT_SUCCESS;

  if (cmdline_parser_required2(args_info, prog_name, 0) > 0)
    result = EXIT_FAILURE;

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error)
{
  int error_occurred = 0;
  FIX_UNUSED (additional_error);

  /* checks for required options */
  if (! args_info->data_given)
    {
      fprintf (stderr, "%s: '--data' ('-d') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  
  /* checks for dependences among options */

  return error_occurred;
}

/*
 * Extracted from the glibc source tree, version 2.3.6
 *
 * Licensed under the GPL as per the whole glibc source tree.
 *
 * This file was modified so that getopt_long can be called
 * many times without risking previous memory to be spoiled.
 *
 * Modified by Andre Noll and Lorenzo Bettini for use in
 * GNU gengetopt generated files.
 *
 */

/* 
 * we must include anything we need since this file is not thought to be
 * inserted in a file already using getopt.h
 *
 * Lorenzo
 */

struct option
{
  const char *name;
  /* has_arg can't be an enum because some compilers complain about
     type mismatches in all the code that assumes it is an int.  */
  int has_arg;
  int *flag;
  int val;
};

/* This version of `getopt' appears to the caller like standard Unix `getopt'
   but it behaves differently for the user, since it allows the user
   to intersperse the options with the other arguments.

   As `getopt' works, it permutes the elements of ARGV so that,
   when it is done, all the options precede everything else.  Thus
   all application programs are extended to handle flexible argument order.
*/
/*
   If the field `flag' is not NULL, it points to a variable that is set
   to the value given in the field `val' when the option is found, but
   left unchanged if the option is not found.

   To have a long-named option do something other than set an `int' to
   a compiled-in constant, such as set a value from `custom_optarg', set the
   option's `flag' field to zero and its `val' field to a nonzero
   value (the equivalent single-letter option character, if there is
   one).  For long options that have a zero `flag' field, `getopt'
   returns the contents of the `val' field.  */

/* Names for the values of the `has_arg' field of `struct option'.  */
#ifndef no_argument
#define no_argument		0
#endif

#ifndef required_argument
#define required_argument	1
#endif

#ifndef optional_argument
#define optional_argument	2
#endif

struct custom_getopt_data {
	/*
	 * These have exactly the same meaning as the corresponding global variables,
	 * except that they are used for the reentrant versions of getopt.
	 */
	int custom_optind;
	int custom_opterr;
	int custom_optopt;
	char *custom_optarg;

	/* True if the internal members have been initialized.  */
	int initialized;

	/*
	 * The next char to be scanned in the option-element in which the last option
	 * character we returned was found.  This allows us to pick up the scan where
	 * we left off.  If this is zero, or a null string, it means resume the scan by
	 * advancing to the next ARGV-element.
	 */
	char *nextchar;

	/*
	 * Describe the part of ARGV that contains non-options that have been skipped.
	 * `first_nonopt' is the index in ARGV of the first of them; `last_nonopt' is
	 * the index after the last of them.
	 */
	int first_nonopt;
	int last_nonopt;
};

/*
 * the variables optarg, optind, opterr and optopt are renamed with
 * the custom_ prefix so that they don't interfere with getopt ones.
 *
 * Moreover they're static so they are visible only from within the
 * file where this very file will be included.
 */

/*
 * For communication from `custom_getopt' to the caller.  When `custom_getopt' finds an
 * option that takes an argument, the argument value is returned here.
 */
static char *custom_optarg;

/*
 * Index in ARGV of the next element to be scanned.  This is used for
 * communication to and from the caller and for communication between
 * successive calls to `custom_getopt'.
 *
 * On entry to `custom_getopt', 1 means this is the first call; initialize.
 *
 * When `custom_getopt' returns -1, this is the index of the first of the non-option
 * elements that the caller should itself scan.
 *
 * Otherwise, `custom_optind' communicates from one call to the next how much of ARGV
 * has been scanned so far.
 *
 * 1003.2 says this must be 1 before any call.
 */
static int custom_optind = 1;

/*
 * Callers store zero here to inhibit the error message for unrecognized
 * options.
 */
static int custom_opterr = 1;

/*
 * Set to an option character which was unrecognized.  This must be initialized
 * on some systems to avoid linking in the system's own getopt implementation.
 */
static int custom_optopt = '?';

/*
 * Exchange two adjacent subsequences of ARGV.  One subsequence is elements
 * [first_nonopt,last_nonopt) which contains all the non-options that have been
 * skipped so far.  The other is elements [last_nonopt,custom_optind), which contains
 * all the options processed since those non-options were skipped.
 * `first_nonopt' and `last_nonopt' are relocated so that they describe the new
 * indices of the non-options in ARGV after they are moved.
 */
static void exchange(char **argv, struct custom_getopt_data *d)
{
	int bottom = d->first_nonopt;
	int middle = d->last_nonopt;
	int top = d->custom_optind;
	char *tem;

	/*
	 * Exchange the shorter segment with the far end of the longer segment.
	 * That puts the shorter segment into the right place.  It leaves the
	 * longer segment in the right place overall, but it consists of two
	 * parts that need to be swapped next.
	 */
	while (top > middle && middle > bottom) {
		if (top - middle > middle - bottom) {
			/* Bottom segment is the short one.  */
			int len = middle - bottom;
			int i;

			/* Swap it with the top part of the top segment.  */
			for (i = 0; i < len; i++) {
				tem = argv[bottom + i];
				argv[bottom + i] =
					argv[top - (middle - bottom) + i];
				argv[top - (middle - bottom) + i] = tem;
			}
			/* Exclude the moved bottom segment from further swapping.  */
			top -= len;
		} else {
			/* Top segment is the short one.  */
			int len = top - middle;
			int i;

			/* Swap it with the bottom part of the bottom segment.  */
			for (i = 0; i < len; i++) {
				tem = argv[bottom + i];
				argv[bottom + i] = argv[middle + i];
				argv[middle + i] = tem;
			}
			/* Exclude the moved top segment from further swapping.  */
			bottom += len;
		}
	}
	/* Update records for the slots the non-options now occupy.  */
	d->first_nonopt += (d->custom_optind - d->last_nonopt);
	d->last_nonopt = d->custom_optind;
}

/* Initialize the internal data when the first call is made.  */
static void custom_getopt_initialize(struct custom_getopt_data *d)
{
	/*
	 * Start processing options with ARGV-element 1 (since ARGV-element 0
	 * is the program name); the sequence of previously skipped non-option
	 * ARGV-elements is empty.
	 */
	d->first_nonopt = d->last_nonopt = d->custom_optind;
	d->nextchar = NULL;
	d->initialized = 1;
}

#define NONOPTION_P (argv[d->custom_optind][0] != '-' || argv[d->custom_optind][1] == '\0')

/* return: zero: continue, nonzero: return given value to user */
static int shuffle_argv(int argc, char *const *argv,const struct option *longopts,
	struct custom_getopt_data *d)
{
	/*
	 * Give FIRST_NONOPT & LAST_NONOPT rational values if CUSTOM_OPTIND has been
	 * moved back by the user (who may also have changed the arguments).
	 */
	if (d->last_nonopt > d->custom_optind)
		d->last_nonopt = d->custom_optind;
	if (d->first_nonopt > d->custom_optind)
		d->first_nonopt = d->custom_optind;
	/*
	 * If we have just processed some options following some
	 * non-options, exchange them so that the options come first.
	 */
	if (d->first_nonopt != d->last_nonopt &&
			d->last_nonopt != d->custom_optind)
		exchange((char **) argv, d);
	else if (d->last_nonopt != d->custom_optind)
		d->first_nonopt = d->custom_optind;
	/*
	 * Skip any additional non-options and extend the range of
	 * non-options previously skipped.
	 */
	while (d->custom_optind < argc && NONOPTION_P)
		d->custom_optind++;
	d->last_nonopt = d->custom_optind;
	/*
	 * The special ARGV-element `--' means premature end of options.  Skip
	 * it like a null option, then exchange with previous non-options as if
	 * it were an option, then skip everything else like a non-option.
	 */
	if (d->custom_optind != argc && !strcmp(argv[d->custom_optind], "--")) {
		d->custom_optind++;
		if (d->first_nonopt != d->last_nonopt
				&& d->last_nonopt != d->custom_optind)
			exchange((char **) argv, d);
		else if (d->first_nonopt == d->last_nonopt)
			d->first_nonopt = d->custom_optind;
		d->last_nonopt = argc;
		d->custom_optind = argc;
	}
	/*
	 * If we have done all the ARGV-elements, stop the scan and back over
	 * any non-options that we skipped and permuted.
	 */
	if (d->custom_optind == argc) {
		/*
		 * Set the next-arg-index to point at the non-options that we
		 * previously skipped, so the caller will digest them.
		 */
		if (d->first_nonopt != d->last_nonopt)
			d->custom_optind = d->first_nonopt;
		return -1;
	}
	/*
	 * If we have come to a non-option and did not permute it, either stop
	 * the scan or describe it to the caller and pass it by.
	 */
	if (NONOPTION_P) {
		d->custom_optarg = argv[d->custom_optind++];
		return 1;
	}
	/*
	 * We have found another option-ARGV-element. Skip the initial
	 * punctuation.
	 */
	d->nextchar = (argv[d->custom_optind] + 1 + (longopts != NULL && argv[d->custom_optind][1] == '-'));
	return 0;
}

/*
 * Check whether the ARGV-element is a long option.
 *
 * If there's a long option "fubar" and the ARGV-element is "-fu", consider
 * that an abbreviation of the long option, just like "--fu", and not "-f" with
 * arg "u".
 *
 * This distinction seems to be the most useful approach.
 *
 */
static int check_long_opt(int argc, char *const *argv, const char *optstring,
		const struct option *longopts, int *longind,
		int print_errors, struct custom_getopt_data *d)
{
	char *nameend;
	const struct option *p;
	const struct option *pfound = NULL;
	int exact = 0;
	int ambig = 0;
	int indfound = -1;
	int option_index;

	for (nameend = d->nextchar; *nameend && *nameend != '='; nameend++)
		/* Do nothing.  */ ;

	/* Test all long options for either exact match or abbreviated matches */
	for (p = longopts, option_index = 0; p->name; p++, option_index++)
		if (!strncmp(p->name, d->nextchar, nameend - d->nextchar)) {
			if ((unsigned int) (nameend - d->nextchar)
					== (unsigned int) strlen(p->name)) {
				/* Exact match found.  */
				pfound = p;
				indfound = option_index;
				exact = 1;
				break;
			} else if (pfound == NULL) {
				/* First nonexact match found.  */
				pfound = p;
				indfound = option_index;
			} else if (pfound->has_arg != p->has_arg
					|| pfound->flag != p->flag
					|| pfound->val != p->val)
				/* Second or later nonexact match found.  */
				ambig = 1;
		}
	if (ambig && !exact) {
		if (print_errors) {
			fprintf(stderr,
				"%s: option `%s' is ambiguous\n",
				argv[0], argv[d->custom_optind]);
		}
		d->nextchar += strlen(d->nextchar);
		d->custom_optind++;
		d->custom_optopt = 0;
		return '?';
	}
	if (pfound) {
		option_index = indfound;
		d->custom_optind++;
		if (*nameend) {
			if (pfound->has_arg != no_argument)
				d->custom_optarg = nameend + 1;
			else {
				if (print_errors) {
					if (argv[d->custom_optind - 1][1] == '-') {
						/* --option */
						fprintf(stderr, "%s: option `--%s' doesn't allow an argument\n",
							argv[0], pfound->name);
					} else {
						/* +option or -option */
						fprintf(stderr, "%s: option `%c%s' doesn't allow an argument\n",
							argv[0], argv[d->custom_optind - 1][0], pfound->name);
					}

				}
				d->nextchar += strlen(d->nextchar);
				d->custom_optopt = pfound->val;
				return '?';
			}
		} else if (pfound->has_arg == required_argument) {
			if (d->custom_optind < argc)
				d->custom_optarg = argv[d->custom_optind++];
			else {
				if (print_errors) {
					fprintf(stderr,
						"%s: option `%s' requires an argument\n",
						argv[0],
						argv[d->custom_optind - 1]);
				}
				d->nextchar += strlen(d->nextchar);
				d->custom_optopt = pfound->val;
				return optstring[0] == ':' ? ':' : '?';
			}
		}
		d->nextchar += strlen(d->nextchar);
		if (longind != NULL)
			*longind = option_index;
		if (pfound->flag) {
			*(pfound->flag) = pfound->val;
			return 0;
		}
		return pfound->val;
	}
	/*
	 * Can't find it as a long option.  If this is not getopt_long_only, or
	 * the option starts with '--' or is not a valid short option, then
	 * it's an error.  Otherwise interpret it as a short option.
	 */
	if (print_errors) {
		if (argv[d->custom_optind][1] == '-') {
			/* --option */
			fprintf(stderr,
				"%s: unrecognized option `--%s'\n",
				argv[0], d->nextchar);
		} else {
			/* +option or -option */
			fprintf(stderr,
				"%s: unrecognized option `%c%s'\n",
				argv[0], argv[d->custom_optind][0],
				d->nextchar);
		}
	}
	d->nextchar = (char *) "";
	d->custom_optind++;
	d->custom_optopt = 0;
	return '?';
}

static int check_short_opt(int argc, char *const *argv, const char *optstring,
		int print_errors, struct custom_getopt_data *d)
{
	char c = *d->nextchar++;
	const char *temp = strchr(optstring, c);

	/* Increment `custom_optind' when we start to process its last character.  */
	if (*d->nextchar == '\0')
		++d->custom_optind;
	if (!temp || c == ':') {
		if (print_errors)
			fprintf(stderr, "%s: invalid option -- %c\n", argv[0], c);

		d->custom_optopt = c;
		return '?';
	}
	if (temp[1] == ':') {
		if (temp[2] == ':') {
			/* This is an option that accepts an argument optionally.  */
			if (*d->nextchar != '\0') {
				d->custom_optarg = d->nextchar;
				d->custom_optind++;
			} else
				d->custom_optarg = NULL;
			d->nextchar = NULL;
		} else {
			/* This is an option that requires an argument.  */
			if (*d->nextchar != '\0') {
				d->custom_optarg = d->nextchar;
				/*
				 * If we end this ARGV-element by taking the
				 * rest as an arg, we must advance to the next
				 * element now.
				 */
				d->custom_optind++;
			} else if (d->custom_optind == argc) {
				if (print_errors) {
					fprintf(stderr,
						"%s: option requires an argument -- %c\n",
						argv[0], c);
				}
				d->custom_optopt = c;
				if (optstring[0] == ':')
					c = ':';
				else
					c = '?';
			} else
				/*
				 * We already incremented `custom_optind' once;
				 * increment it again when taking next ARGV-elt
				 * as argument.
				 */
				d->custom_optarg = argv[d->custom_optind++];
			d->nextchar = NULL;
		}
	}
	return c;
}

/*
 * Scan elements of ARGV for option characters given in OPTSTRING.
 *
 * If an element of ARGV starts with '-', and is not exactly "-" or "--",
 * then it is an option element.  The characters of this element
 * (aside from the initial '-') are option characters.  If `getopt'
 * is called repeatedly, it returns successively each of the option characters
 * from each of the option elements.
 *
 * If `getopt' finds another option character, it returns that character,
 * updating `custom_optind' and `nextchar' so that the next call to `getopt' can
 * resume the scan with the following option character or ARGV-element.
 *
 * If there are no more option characters, `getopt' returns -1.
 * Then `custom_optind' is the index in ARGV of the first ARGV-element
 * that is not an option.  (The ARGV-elements have been permuted
 * so that those that are not options now come last.)
 *
 * OPTSTRING is a string containing the legitimate option characters.
 * If an option character is seen that is not listed in OPTSTRING,
 * return '?' after printing an error message.  If you set `custom_opterr' to
 * zero, the error message is suppressed but we still return '?'.
 *
 * If a char in OPTSTRING is followed by a colon, that means it wants an arg,
 * so the following text in the same ARGV-element, or the text of the following
 * ARGV-element, is returned in `custom_optarg'.  Two colons mean an option that
 * wants an optional arg; if there is text in the current ARGV-element,
 * it is returned in `custom_optarg', otherwise `custom_optarg' is set to zero.
 *
 * If OPTSTRING starts with `-' or `+', it requests different methods of
 * handling the non-option ARGV-elements.
 * See the comments about RETURN_IN_ORDER and REQUIRE_ORDER, above.
 *
 * Long-named options begin with `--' instead of `-'.
 * Their names may be abbreviated as long as the abbreviation is unique
 * or is an exact match for some defined option.  If they have an
 * argument, it follows the option name in the same ARGV-element, separated
 * from the option name by a `=', or else the in next ARGV-element.
 * When `getopt' finds a long-named option, it returns 0 if that option's
 * `flag' field is nonzero, the value of the option's `val' field
 * if the `flag' field is zero.
 *
 * The elements of ARGV aren't really const, because we permute them.
 * But we pretend they're const in the prototype to be compatible
 * with other systems.
 *
 * LONGOPTS is a vector of `struct option' terminated by an
 * element containing a name which is zero.
 *
 * LONGIND returns the index in LONGOPT of the long-named option found.
 * It is only valid when a long-named option has been found by the most
 * recent call.
 *
 * Return the option character from OPTS just read.  Return -1 when there are
 * no more options.  For unrecognized options, or options missing arguments,
 * `custom_optopt' is set to the option letter, and '?' is returned.
 *
 * The OPTS string is a list of characters which are recognized option letters,
 * optionally followed by colons, specifying that that letter takes an
 * argument, to be placed in `custom_optarg'.
 *
 * If a letter in OPTS is followed by two colons, its argument is optional.
 * This behavior is specific to the GNU `getopt'.
 *
 * The argument `--' causes premature termination of argument scanning,
 * explicitly telling `getopt' that there are no more options.  If OPTS begins
 * with `--', then non-option arguments are treated as arguments to the option
 * '\0'.  This behavior is specific to the GNU `getopt'.
 */

static int getopt_internal_r(int argc, char *const *argv, const char *optstring,
		const struct option *longopts, int *longind,
		struct custom_getopt_data *d)
{
	int ret, print_errors = d->custom_opterr;

	if (optstring[0] == ':')
		print_errors = 0;
	if (argc < 1)
		return -1;
	d->custom_optarg = NULL;

	/* 
	 * This is a big difference with GNU getopt, since optind == 0
	 * means initialization while here 1 means first call.
	 */
	if (d->custom_optind == 0 || !d->initialized) {
		if (d->custom_optind == 0)
			d->custom_optind = 1;	/* Don't scan ARGV[0], the program name.  */
		custom_getopt_initialize(d);
	}
	if (d->nextchar == NULL || *d->nextchar == '\0') {
		ret = shuffle_argv(argc, argv, longopts, d);
		if (ret)
			return ret;
	}
	if (longopts && (argv[d->custom_optind][1] == '-' ))
		return check_long_opt(argc, argv, optstring, longopts,
			longind, print_errors, d);
	return check_short_opt(argc, argv, optstring, print_errors, d);
}

static int custom_getopt_internal(int argc, char *const *argv, const char *optstring,
	const struct option *longopts, int *longind)
{
	int result;
	/* Keep a global copy of all internal members of d */
	static struct custom_getopt_data d;

	d.custom_optind = custom_optind;
	d.custom_opterr = custom_opterr;
	result = getopt_internal_r(argc, argv, optstring, longopts,
		longind, &d);
	custom_optind = d.custom_optind;
	custom_optarg = d.custom_optarg;
	custom_optopt = d.custom_optopt;
	return result;
}

static int custom_getopt_long (int argc, char *const *argv, const char *options,
	const struct option *long_options, int *opt_index)
{
	return custom_getopt_internal(argc, argv, options, long_options,
		opt_index);
}


static char *package_name = 0;

/**
 * @brief updates an option
 * @param field the generic pointer to the field to update
 * @param orig_field the pointer to the orig field
 * @param field_given the pointer to the number of occurrence of this option
 * @param prev_given the pointer to the number of occurrence already seen
 * @param value the argument for this option (if null no arg was specified)
 * @param possible_values the possible values for this option (if specified)
 * @param default_value the default value (in case the option only accepts fixed values)
 * @param arg_type the type of this option
 * @param check_ambiguity @see cmdline_parser_params.check_ambiguity
 * @param override @see cmdline_parser_params.override
 * @param no_free whether to free a possible previous value
 * @param multiple_option whether this is a multiple option
 * @param long_opt the corresponding long option
 * @param short_opt the corresponding short option (or '-' if none)
 * @param additional_error possible further error specification
 */
static
int update_arg(void *field, char **orig_field,
               unsigned int *field_given, unsigned int *prev_given, 
               char *value, const char *possible_values[],
               const char *default_value,
               cmdline_parser_arg_type arg_type,
               int check_ambiguity, int override,
               int no_free, int multiple_option,
               const char *long_opt, char short_opt,
               const char *additional_error)
{
  char *stop_char = 0;
  const char *val = value;
  int found;
  char **string_field;
  FIX_UNUSED (field);

  stop_char = 0;
  found = 0;

  if (!multiple_option && prev_given && (*prev_given || (check_ambiguity && *field_given)))
    {
      if (short_opt != '-')
        fprintf (stderr, "%s: `--%s' (`-%c') option given more than once%s\n", 
               package_name, long_opt, short_opt,
               (additional_error ? additional_error : ""));
      else
        fprintf (stderr, "%s: `--%s' option given more than once%s\n", 
               package_name, long_opt,
               (additional_error ? additional_error : ""));
      return 1; /* failure */
    }

  if (possible_values && (found = check_possible_values((value ? value : default_value), possible_values)) < 0)
    {
      if (short_opt != '-')
        fprintf (stderr, "%s: %s argument, \"%s\", for option `--%s' (`-%c')%s\n", 
          package_name, (found == -2) ? "ambiguous" : "invalid", value, long_opt, short_opt,
          (additional_error ? additional_error : ""));
      else
        fprintf (stderr, "%s: %s argument, \"%s\", for option `--%s'%s\n", 
          package_name, (found == -2) ? "ambiguous" : "invalid", value, long_opt,
          (additional_error ? additional_error : ""));
      return 1; /* failure */
    }
    
  if (field_given && *field_given && ! override)
    return 0;
  if (prev_given)
    (*prev_given)++;
  if (field_given)
    (*field_given)++;
  if (possible_values)
    val = possible_values[found];

  switch(arg_type) {
  case ARG_FLAG:
    *((int *)field) = !*((int *)field);
    break;
  case ARG_INT:
    if (val) *((int *)field) = strtol (val, &stop_char, 0);
    break;
  case ARG_FLOAT:
    if (val) *((float *)field) = (float)strtod (val, &stop_char);
    break;
  case ARG_STRING:
    if (val) {
      string_field = (char **)field;
      if (!no_free && *string_field)
        free (*string_field); /* free previous string */
      *string_field = gengetopt_strdup (val);
    }
    break;
  default:
    break;
  };

  /* check numeric conversion */
  switch(arg_type) {
  case ARG_INT:
  case ARG_FLOAT:
    if (val && !(stop_char && *stop_char == '\0')) {
      fprintf(stderr, "%s: invalid numeric value: %s\n", package_name, val);
      return 1; /* failure */
    }
    break;
  default:
    ;
  };

  /* store the original value */
  switch(arg_type) {
  case ARG_NO:
  case ARG_FLAG:
    break;
  default:
    if (value && orig_field) {
      if (no_free) {
        *orig_field = value;
      } else {
        if (*orig_field)
          free (*orig_field); /* free previous string */
        *orig_field = gengetopt_strdup (value);
      }
    }
  };

  return 0; /* OK */
}


static int check_modes(
  int given1[], const char *options1[],
                       int given2[], const char *options2[])
{
  int i = 0, j = 0, errors = 0;
  
  while (given1[i] >= 0) {
    if (given1[i]) {
      while (given2[j] >= 0) {
        if (given2[j]) {
          ++errors;
          fprintf(stderr, "%s: option %s conflicts with option %s\n",
                  package_name, options1[i], options2[j]);
        }
        ++j;
      }
    }
    ++i;
  }
  
  return errors;
}

int
cmdline_parser_internal (
  int argc, char **argv, struct gengetopt_args_info *args_info,
                        struct cmdline_parser_params *params, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error_occurred = 0;
  struct gengetopt_args_info local_args_info;
  
  int override;
  int initialize;
  int check_required;
  int check_ambiguity;

  char *optarg;
  int optind;
  int opterr;
  int optopt;
  
  package_name = argv[0];
  
  override = params->override;
  initialize = params->initialize;
  check_required = params->check_required;
  check_ambiguity = params->check_ambiguity;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = params->print_errors;
  optopt = '?';

  while (1)
    {
      int option_index = 0;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "noui",	0, NULL, 0 },
        { "data",	1, NULL, 'd' },
        { "output",	1, NULL, 'f' },
        { "clobber",	0, NULL, 0 },
        { "target",	1, NULL, 't' },
        { "wavmin",	1, NULL, 0 },
        { "wavmax",	1, NULL, 0 },
        { "uvmax",	1, NULL, 0 },
        { "it",	1, NULL, 0 },
        { "regul",	1, NULL, 'e' },
        { "autoalpha",	1, NULL, 'r' },
        { "alpha",	1, NULL, 'a' },
        { "ferr",	1, NULL, 0 },
        { "berr",	1, NULL, 0 },
        { "v2a",	1, NULL, 0 },
        { "v2b",	1, NULL, 0 },
        { "t3ampa",	1, NULL, 0 },
        { "t3ampb",	1, NULL, 0 },
        { "t3phia",	1, NULL, 0 },
        { "t3phib",	1, NULL, 0 },
        { "forcext",	0, NULL, 0 },
        { "dim",	1, NULL, 'w' },
        { "pixelsize",	1, NULL, 'p' },
        { "mf",	1, NULL, 0 },
        { "mt",	1, NULL, 0 },
        { "mw",	1, NULL, 0 },
        { "sf",	1, NULL, 0 },
        { 0,  0, 0, 0 }
      };

      custom_optarg = optarg;
      custom_optind = optind;
      custom_opterr = opterr;
      custom_optopt = optopt;

      c = custom_getopt_long (argc, argv, "hVd:f:t:e:r:a:w:p:", long_options, &option_index);

      optarg = custom_optarg;
      optind = custom_optind;
      opterr = custom_opterr;
      optopt = custom_optopt;

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
        
        
          if (update_arg( 0 , 
               0 , &(args_info->version_given),
              &(local_args_info.version_given), optarg, 0, 0, ARG_NO,
              check_ambiguity, override, 0, 0,
              "version", 'V',
              additional_error))
            goto failure;
          cmdline_parser_free (&local_args_info);
          return 0;
        
          break;
        case 'd':	/* Input OIFITS data filename.  */
        
        
          if (update_arg( (void *)&(args_info->data_arg), 
               &(args_info->data_orig), &(args_info->data_given),
              &(local_args_info.data_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "data", 'd',
              additional_error))
            goto failure;
        
          break;
        case 'f':	/* Output filename.  */
        
        
          if (update_arg( (void *)&(args_info->output_arg), 
               &(args_info->output_orig), &(args_info->output_given),
              &(local_args_info.output_given), optarg, 0, "output.fits", ARG_STRING,
              check_ambiguity, override, 0, 0,
              "output", 'f',
              additional_error))
            goto failure;
        
          break;
        case 't':	/* Name of target to select.  */
        
        
          if (update_arg( (void *)&(args_info->target_arg), 
               &(args_info->target_orig), &(args_info->target_given),
              &(local_args_info.target_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "target", 't',
              additional_error))
            goto failure;
        
          break;
        case 'e':	/* Regularization function
        1: Gull-Skilling entropy
        2: Positive/negative Gull-Skilling entropy
        4: Quadratic.  */
        
        
          if (update_arg( (void *)&(args_info->regul_arg), 
               &(args_info->regul_orig), &(args_info->regul_given),
              &(local_args_info.regul_given), optarg, cmdline_parser_regul_values, "1", ARG_INT,
              check_ambiguity, override, 0, 0,
              "regul", 'e',
              additional_error))
            goto failure;
        
          break;
        case 'r':	/* Regularization hyperparameter estimation
        1: Classic Bayesian with known noise scale
        2: Classic Bayesian with simultaneous estimation of the noise scale
        3: Uses the user-provided alpha value
        4: Historic Chisquared=Ndata (fast, but non-Bayesian).  */
        
        
          if (update_arg( (void *)&(args_info->autoalpha_arg), 
               &(args_info->autoalpha_orig), &(args_info->autoalpha_given),
              &(local_args_info.autoalpha_given), optarg, cmdline_parser_autoalpha_values, "4", ARG_INT,
              check_ambiguity, override, 0, 0,
              "autoalpha", 'r',
              additional_error))
            goto failure;
        
          break;
        case 'a':	/* Regularization hyperparameter (-r 3 to enable).  */
        
        
          if (update_arg( (void *)&(args_info->alpha_arg), 
               &(args_info->alpha_orig), &(args_info->alpha_given),
              &(local_args_info.alpha_given), optarg, 0, "100.0", ARG_FLOAT,
              check_ambiguity, override, 0, 0,
              "alpha", 'a',
              additional_error))
            goto failure;
        
          break;
        case 'w':	/* Reconstructed image width (pixels).  */
        
        
          if (update_arg( (void *)&(args_info->dim_arg), 
               &(args_info->dim_orig), &(args_info->dim_given),
              &(local_args_info.dim_given), optarg, 0, "128", ARG_INT,
              check_ambiguity, override, 0, 0,
              "dim", 'w',
              additional_error))
            goto failure;
        
          break;
        case 'p':	/* Reconstructed image pixel size (mas) (default=automatic).  */
        
        
          if (update_arg( (void *)&(args_info->pixelsize_arg), 
               &(args_info->pixelsize_orig), &(args_info->pixelsize_given),
              &(local_args_info.pixelsize_given), optarg, 0, 0, ARG_FLOAT,
              check_ambiguity, override, 0, 0,
              "pixelsize", 'p',
              additional_error))
            goto failure;
        
          break;

        case 0:	/* Long option with no short option */
          /* Disable user prompts and plotting.  */
          if (strcmp (long_options[option_index].name, "noui") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->noui_flag), 0, &(args_info->noui_given),
                &(local_args_info.noui_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "noui", '-',
                additional_error))
              goto failure;
          
          }
          /* Overwrite existing output file.  */
          else if (strcmp (long_options[option_index].name, "clobber") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->clobber_flag), 0, &(args_info->clobber_given),
                &(local_args_info.clobber_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "clobber", '-',
                additional_error))
              goto failure;
          
          }
          /* Minimum wavelength to select (nm).  */
          else if (strcmp (long_options[option_index].name, "wavmin") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->wavmin_arg), 
                 &(args_info->wavmin_orig), &(args_info->wavmin_given),
                &(local_args_info.wavmin_given), optarg, 0, "0.0", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "wavmin", '-',
                additional_error))
              goto failure;
          
          }
          /* Maximum wavelength to select (nm).  */
          else if (strcmp (long_options[option_index].name, "wavmax") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->wavmax_arg), 
                 &(args_info->wavmax_orig), &(args_info->wavmax_given),
                &(local_args_info.wavmax_given), optarg, 0, "1E9", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "wavmax", '-',
                additional_error))
              goto failure;
          
          }
          /* Maximum uv radius to select (waves).  */
          else if (strcmp (long_options[option_index].name, "uvmax") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->uvmax_arg), 
                 &(args_info->uvmax_orig), &(args_info->uvmax_given),
                &(local_args_info.uvmax_given), optarg, 0, "1E11", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "uvmax", '-',
                additional_error))
              goto failure;
          
          }
          /* Maximum number of iterations to run.  */
          else if (strcmp (long_options[option_index].name, "it") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->it_arg), 
                 &(args_info->it_orig), &(args_info->it_given),
                &(local_args_info.it_given), optarg, 0, "200", ARG_INT,
                check_ambiguity, override, 0, 0,
                "it", '-',
                additional_error))
              goto failure;
          
          }
          /* Error on zero baseline powerspectrum.  */
          else if (strcmp (long_options[option_index].name, "ferr") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->ferr_arg), 
                 &(args_info->ferr_orig), &(args_info->ferr_given),
                &(local_args_info.ferr_given), optarg, 0, "0.1", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "ferr", '-',
                additional_error))
              goto failure;
          
          }
          /* Type of errors on the rotated bispectrum vector
          0: Classic elliptic approximation
          1: 'Full' elliptic approximation (Meimon et al.).  */
          else if (strcmp (long_options[option_index].name, "berr") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->berr_arg), 
                 &(args_info->berr_orig), &(args_info->berr_given),
                &(local_args_info.berr_given), optarg, cmdline_parser_berr_values, "0", ARG_INT,
                check_ambiguity, override, 0, 0,
                "berr", '-',
                additional_error))
              goto failure;
          
          }
          /* Multiplicative factor a for powerspectrum errors
          (e'= a * e + b).  */
          else if (strcmp (long_options[option_index].name, "v2a") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->v2a_arg), 
                 &(args_info->v2a_orig), &(args_info->v2a_given),
                &(local_args_info.v2a_given), optarg, 0, "1.0", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "v2a", '-',
                additional_error))
              goto failure;
          
          }
          /* Additive offset b for powerspectrum errors
          (e'= a * e + b).  */
          else if (strcmp (long_options[option_index].name, "v2b") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->v2b_arg), 
                 &(args_info->v2b_orig), &(args_info->v2b_given),
                &(local_args_info.v2b_given), optarg, 0, "0.0", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "v2b", '-',
                additional_error))
              goto failure;
          
          }
          /* Multiplicative factor a for triple amplitude errors
          (e'= a * e + b).  */
          else if (strcmp (long_options[option_index].name, "t3ampa") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->t3ampa_arg), 
                 &(args_info->t3ampa_orig), &(args_info->t3ampa_given),
                &(local_args_info.t3ampa_given), optarg, 0, "1.0", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "t3ampa", '-',
                additional_error))
              goto failure;
          
          }
          /* Additive offset b for triple amplitude errors
          (e'= a * e + b).  */
          else if (strcmp (long_options[option_index].name, "t3ampb") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->t3ampb_arg), 
                 &(args_info->t3ampb_orig), &(args_info->t3ampb_given),
                &(local_args_info.t3ampb_given), optarg, 0, "0.0", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "t3ampb", '-',
                additional_error))
              goto failure;
          
          }
          /* Multiplicative factor a for closure phase errors
          (e'= a * e + b).  */
          else if (strcmp (long_options[option_index].name, "t3phia") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->t3phia_arg), 
                 &(args_info->t3phia_orig), &(args_info->t3phia_given),
                &(local_args_info.t3phia_given), optarg, 0, "1.0", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "t3phia", '-',
                additional_error))
              goto failure;
          
          }
          /* Additive offset b for closure phase errors
          (e'= a * e + b).  */
          else if (strcmp (long_options[option_index].name, "t3phib") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->t3phib_arg), 
                 &(args_info->t3phib_orig), &(args_info->t3phib_given),
                &(local_args_info.t3phib_given), optarg, 0, "0.0", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "t3phib", '-',
                additional_error))
              goto failure;
          
          }
          /* Force triple amplitude computation from powerspectra.  */
          else if (strcmp (long_options[option_index].name, "forcext") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->forcext_flag), 0, &(args_info->forcext_given),
                &(local_args_info.forcext_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "forcext", '-',
                additional_error))
              goto failure;
          
          }
          /* Total flux of the initial/prior image.  */
          else if (strcmp (long_options[option_index].name, "mf") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->mf_arg), 
                 &(args_info->mf_orig), &(args_info->mf_given),
                &(local_args_info.mf_given), optarg, 0, "0.01", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "mf", '-',
                additional_error))
              goto failure;
          
          }
          /* Initial/prior image model type
          0: flat
          1: Dirac
          2: uniform disk
          3: Gaussian
          4: Lorentzian.  */
          else if (strcmp (long_options[option_index].name, "mt") == 0)
          {
            args_info->model_mode_counter += 1;
          
          
            if (update_arg( (void *)&(args_info->mt_arg), 
                 &(args_info->mt_orig), &(args_info->mt_given),
                &(local_args_info.mt_given), optarg, cmdline_parser_mt_values, "3", ARG_INT,
                check_ambiguity, override, 0, 0,
                "mt", '-',
                additional_error))
              goto failure;
          
          }
          /* Initial/prior image model width (mas).  */
          else if (strcmp (long_options[option_index].name, "mw") == 0)
          {
            args_info->model_mode_counter += 1;
          
          
            if (update_arg( (void *)&(args_info->mw_arg), 
                 &(args_info->mw_orig), &(args_info->mw_given),
                &(local_args_info.mw_given), optarg, 0, "10.0", ARG_FLOAT,
                check_ambiguity, override, 0, 0,
                "mw", '-',
                additional_error))
              goto failure;
          
          }
          /* Initial/prior image filename.  */
          else if (strcmp (long_options[option_index].name, "sf") == 0)
          {
            args_info->image_mode_counter += 1;
          
          
            if (update_arg( (void *)&(args_info->sf_arg), 
                 &(args_info->sf_orig), &(args_info->sf_given),
                &(local_args_info.sf_given), optarg, 0, 0, ARG_STRING,
                check_ambiguity, override, 0, 0,
                "sf", '-',
                additional_error))
              goto failure;
          
          }
          
          break;
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



  if (args_info->image_mode_counter && args_info->model_mode_counter) {
    int image_given[] = {args_info->sf_given,  -1};
    const char *image_desc[] = {"--sf",  0};
    int model_given[] = {args_info->mt_given, args_info->mw_given,  -1};
    const char *model_desc[] = {"--mt", "--mw",  0};
    error_occurred += check_modes(image_given, image_desc, model_given, model_desc);
  }
  
  if (check_required)
    {
      error_occurred += cmdline_parser_required2 (args_info, argv[0], additional_error);
    }

  cmdline_parser_release (&local_args_info);

  if ( error_occurred )
    return (EXIT_FAILURE);

  return 0;

failure:
  
  cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
