/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "bsmem"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "bsmem"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "2"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int noui_flag;	/**< @brief Disable user prompts and plotting (default=off).  */
  const char *noui_help; /**< @brief Disable user prompts and plotting help description.  */
  char * data_arg;	/**< @brief Input OIFITS data filename.  */
  char * data_orig;	/**< @brief Input OIFITS data filename original value given at command line.  */
  const char *data_help; /**< @brief Input OIFITS data filename help description.  */
  char * output_arg;	/**< @brief Output filename (default='output.fits').  */
  char * output_orig;	/**< @brief Output filename original value given at command line.  */
  const char *output_help; /**< @brief Output filename help description.  */
  int clobber_flag;	/**< @brief Overwrite existing output file (default=off).  */
  const char *clobber_help; /**< @brief Overwrite existing output file help description.  */
  char * target_arg;	/**< @brief Name of target to select.  */
  char * target_orig;	/**< @brief Name of target to select original value given at command line.  */
  const char *target_help; /**< @brief Name of target to select help description.  */
  float wavmin_arg;	/**< @brief Minimum wavelength to select (nm) (default='0.0').  */
  char * wavmin_orig;	/**< @brief Minimum wavelength to select (nm) original value given at command line.  */
  const char *wavmin_help; /**< @brief Minimum wavelength to select (nm) help description.  */
  float wavmax_arg;	/**< @brief Maximum wavelength to select (nm) (default='1E9').  */
  char * wavmax_orig;	/**< @brief Maximum wavelength to select (nm) original value given at command line.  */
  const char *wavmax_help; /**< @brief Maximum wavelength to select (nm) help description.  */
  float uvmax_arg;	/**< @brief Maximum uv radius to select (waves) (default='1E11').  */
  char * uvmax_orig;	/**< @brief Maximum uv radius to select (waves) original value given at command line.  */
  const char *uvmax_help; /**< @brief Maximum uv radius to select (waves) help description.  */
  int it_arg;	/**< @brief Maximum number of iterations to run (default='200').  */
  char * it_orig;	/**< @brief Maximum number of iterations to run original value given at command line.  */
  const char *it_help; /**< @brief Maximum number of iterations to run help description.  */
  int regul_arg;	/**< @brief Regularization function
  1: Gull-Skilling entropy
  2: Positive/negative Gull-Skilling entropy
  4: Quadratic (default='1').  */
  char * regul_orig;	/**< @brief Regularization function
  1: Gull-Skilling entropy
  2: Positive/negative Gull-Skilling entropy
  4: Quadratic original value given at command line.  */
  const char *regul_help; /**< @brief Regularization function
  1: Gull-Skilling entropy
  2: Positive/negative Gull-Skilling entropy
  4: Quadratic help description.  */
  int autoalpha_arg;	/**< @brief Regularization hyperparameter estimation
  1: Classic Bayesian with known noise scale
  2: Classic Bayesian with simultaneous estimation of the noise scale
  3: Uses the user-provided alpha value
  4: Historic Chisquared=Ndata (fast, but non-Bayesian) (default='4').  */
  char * autoalpha_orig;	/**< @brief Regularization hyperparameter estimation
  1: Classic Bayesian with known noise scale
  2: Classic Bayesian with simultaneous estimation of the noise scale
  3: Uses the user-provided alpha value
  4: Historic Chisquared=Ndata (fast, but non-Bayesian) original value given at command line.  */
  const char *autoalpha_help; /**< @brief Regularization hyperparameter estimation
  1: Classic Bayesian with known noise scale
  2: Classic Bayesian with simultaneous estimation of the noise scale
  3: Uses the user-provided alpha value
  4: Historic Chisquared=Ndata (fast, but non-Bayesian) help description.  */
  float alpha_arg;	/**< @brief Regularization hyperparameter (-r 3 to enable) (default='100.0').  */
  char * alpha_orig;	/**< @brief Regularization hyperparameter (-r 3 to enable) original value given at command line.  */
  const char *alpha_help; /**< @brief Regularization hyperparameter (-r 3 to enable) help description.  */
  float ferr_arg;	/**< @brief Error on zero baseline powerspectrum (default='0.1').  */
  char * ferr_orig;	/**< @brief Error on zero baseline powerspectrum original value given at command line.  */
  const char *ferr_help; /**< @brief Error on zero baseline powerspectrum help description.  */
  int berr_arg;	/**< @brief Type of errors on the rotated bispectrum vector
  0: Classic elliptic approximation
  1: 'Full' elliptic approximation (Meimon et al.) (default='0').  */
  char * berr_orig;	/**< @brief Type of errors on the rotated bispectrum vector
  0: Classic elliptic approximation
  1: 'Full' elliptic approximation (Meimon et al.) original value given at command line.  */
  const char *berr_help; /**< @brief Type of errors on the rotated bispectrum vector
  0: Classic elliptic approximation
  1: 'Full' elliptic approximation (Meimon et al.) help description.  */
  float v2a_arg;	/**< @brief Multiplicative factor a for powerspectrum errors
  (e'= a * e + b) (default='1.0').  */
  char * v2a_orig;	/**< @brief Multiplicative factor a for powerspectrum errors
  (e'= a * e + b) original value given at command line.  */
  const char *v2a_help; /**< @brief Multiplicative factor a for powerspectrum errors
  (e'= a * e + b) help description.  */
  float v2b_arg;	/**< @brief Additive offset b for powerspectrum errors
  (e'= a * e + b) (default='0.0').  */
  char * v2b_orig;	/**< @brief Additive offset b for powerspectrum errors
  (e'= a * e + b) original value given at command line.  */
  const char *v2b_help; /**< @brief Additive offset b for powerspectrum errors
  (e'= a * e + b) help description.  */
  float t3ampa_arg;	/**< @brief Multiplicative factor a for triple amplitude errors
  (e'= a * e + b) (default='1.0').  */
  char * t3ampa_orig;	/**< @brief Multiplicative factor a for triple amplitude errors
  (e'= a * e + b) original value given at command line.  */
  const char *t3ampa_help; /**< @brief Multiplicative factor a for triple amplitude errors
  (e'= a * e + b) help description.  */
  float t3ampb_arg;	/**< @brief Additive offset b for triple amplitude errors
  (e'= a * e + b) (default='0.0').  */
  char * t3ampb_orig;	/**< @brief Additive offset b for triple amplitude errors
  (e'= a * e + b) original value given at command line.  */
  const char *t3ampb_help; /**< @brief Additive offset b for triple amplitude errors
  (e'= a * e + b) help description.  */
  float t3phia_arg;	/**< @brief Multiplicative factor a for closure phase errors
  (e'= a * e + b) (default='1.0').  */
  char * t3phia_orig;	/**< @brief Multiplicative factor a for closure phase errors
  (e'= a * e + b) original value given at command line.  */
  const char *t3phia_help; /**< @brief Multiplicative factor a for closure phase errors
  (e'= a * e + b) help description.  */
  float t3phib_arg;	/**< @brief Additive offset b for closure phase errors
  (e'= a * e + b) (default='0.0').  */
  char * t3phib_orig;	/**< @brief Additive offset b for closure phase errors
  (e'= a * e + b) original value given at command line.  */
  const char *t3phib_help; /**< @brief Additive offset b for closure phase errors
  (e'= a * e + b) help description.  */
  int forcext_flag;	/**< @brief Force triple amplitude computation from powerspectra (default=off).  */
  const char *forcext_help; /**< @brief Force triple amplitude computation from powerspectra help description.  */
  int dim_arg;	/**< @brief Reconstructed image width (pixels) (default='128').  */
  char * dim_orig;	/**< @brief Reconstructed image width (pixels) original value given at command line.  */
  const char *dim_help; /**< @brief Reconstructed image width (pixels) help description.  */
  float pixelsize_arg;	/**< @brief Reconstructed image pixel size (mas) (default=automatic).  */
  char * pixelsize_orig;	/**< @brief Reconstructed image pixel size (mas) (default=automatic) original value given at command line.  */
  const char *pixelsize_help; /**< @brief Reconstructed image pixel size (mas) (default=automatic) help description.  */
  float mf_arg;	/**< @brief Total flux of the initial/prior image (default='0.01').  */
  char * mf_orig;	/**< @brief Total flux of the initial/prior image original value given at command line.  */
  const char *mf_help; /**< @brief Total flux of the initial/prior image help description.  */
  int mt_arg;	/**< @brief Initial/prior image model type
  0: flat
  1: Dirac
  2: uniform disk
  3: Gaussian
  4: Lorentzian (default='3').  */
  char * mt_orig;	/**< @brief Initial/prior image model type
  0: flat
  1: Dirac
  2: uniform disk
  3: Gaussian
  4: Lorentzian original value given at command line.  */
  const char *mt_help; /**< @brief Initial/prior image model type
  0: flat
  1: Dirac
  2: uniform disk
  3: Gaussian
  4: Lorentzian help description.  */
  float mw_arg;	/**< @brief Initial/prior image model width (mas) (default='10.0').  */
  char * mw_orig;	/**< @brief Initial/prior image model width (mas) original value given at command line.  */
  const char *mw_help; /**< @brief Initial/prior image model width (mas) help description.  */
  char * sf_arg;	/**< @brief Initial/prior image filename.  */
  char * sf_orig;	/**< @brief Initial/prior image filename original value given at command line.  */
  const char *sf_help; /**< @brief Initial/prior image filename help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int noui_given ;	/**< @brief Whether noui was given.  */
  unsigned int data_given ;	/**< @brief Whether data was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int clobber_given ;	/**< @brief Whether clobber was given.  */
  unsigned int target_given ;	/**< @brief Whether target was given.  */
  unsigned int wavmin_given ;	/**< @brief Whether wavmin was given.  */
  unsigned int wavmax_given ;	/**< @brief Whether wavmax was given.  */
  unsigned int uvmax_given ;	/**< @brief Whether uvmax was given.  */
  unsigned int it_given ;	/**< @brief Whether it was given.  */
  unsigned int regul_given ;	/**< @brief Whether regul was given.  */
  unsigned int autoalpha_given ;	/**< @brief Whether autoalpha was given.  */
  unsigned int alpha_given ;	/**< @brief Whether alpha was given.  */
  unsigned int ferr_given ;	/**< @brief Whether ferr was given.  */
  unsigned int berr_given ;	/**< @brief Whether berr was given.  */
  unsigned int v2a_given ;	/**< @brief Whether v2a was given.  */
  unsigned int v2b_given ;	/**< @brief Whether v2b was given.  */
  unsigned int t3ampa_given ;	/**< @brief Whether t3ampa was given.  */
  unsigned int t3ampb_given ;	/**< @brief Whether t3ampb was given.  */
  unsigned int t3phia_given ;	/**< @brief Whether t3phia was given.  */
  unsigned int t3phib_given ;	/**< @brief Whether t3phib was given.  */
  unsigned int forcext_given ;	/**< @brief Whether forcext was given.  */
  unsigned int dim_given ;	/**< @brief Whether dim was given.  */
  unsigned int pixelsize_given ;	/**< @brief Whether pixelsize was given.  */
  unsigned int mf_given ;	/**< @brief Whether mf was given.  */
  unsigned int mt_given ;	/**< @brief Whether mt was given.  */
  unsigned int mw_given ;	/**< @brief Whether mw was given.  */
  unsigned int sf_given ;	/**< @brief Whether sf was given.  */

  int image_mode_counter; /**< @brief Counter for mode image */
  int model_mode_counter; /**< @brief Counter for mode model */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);

extern const char *cmdline_parser_regul_values[];  /**< @brief Possible values for regul. */
extern const char *cmdline_parser_autoalpha_values[];  /**< @brief Possible values for autoalpha. */
extern const char *cmdline_parser_berr_values[];  /**< @brief Possible values for berr. */
extern const char *cmdline_parser_mt_values[];  /**< @brief Possible values for mt. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
