/**
 * @file
 * Definition of data/model plotting API.
 *
 * Copyright (C) 2015-2017 John Young
 *
 * This file is part of BSMEM:
 * http://www.mrao.cam.ac.uk/research/optical-interferometry/bsmem-software/
 *
 * BSMEM is licensed under a Creative Commons
 * Attribution-NonCommercial-NoDerivatives 4.0 International License.
 * See LICENSE.txt for more details.
 */

#ifndef PLOT_H
#define PLOT_H

#include "GreyImg.h"
#include "BsmemData.h"

void openplot(const GreyImg *, const char *);
void plotimage(const GreyImg *, float, bool);
void plotuv(const BsmemData *);
void plotpow(const BsmemData *);
void plott3(const BsmemData *);
void closeplot(void);

#endif  /* #ifndef PLOT_H */
